#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Définition des fonctions de base de communication du client
# Pour l'instant ce script sert essentiellement à les charger en mémoire pour les utiliser à la main

import os, sys, string, time, random
import socket, ssl
import threading

import json
import hashlib

import client_config
reload(client_config)

from pprint import pprint

sys.path.append(client_config.rsa_path)
import monRSA

def full_read(socket):
    """Lit un message complet sur la socket."""
    # On récupère d'abord la taille du message
    length_str = ''
    char = socket.recv(1)
    while char != '\n':
        length_str += char
        char = socket.recv(1)
    total = int(length_str)
    # On utilise une memoryview pour recevoir les données chunk par chunk efficacement
    view = memoryview(bytearray(total))
    next_offset = 0
    while total - next_offset > 0:
        recv_size = socket.recv_into(view[next_offset:], total - next_offset)
        next_offset += recv_size
    try:
        msg = json.loads(view.tobytes())
    except (TypeError, ValueError) as e:
        raise NKNotJson("L'objet reçu n'est pas un JSON")
    return msg

def connect(sock,where,port=None):
    if port==None:
        port=client_config.port
    try:
        ip={"ici":"localhost","vent":"vent.crans.org","eva":"eva.crans.org","cerebro":"cerebro.crans.org"}[where]
    except:
        ip=where
    sock.connect((ip,port))
    return ssl.wrap_socket(sock,ca_certs=client_config.ca_certfile)
#              cert_reqs=ssl.CERT_NONE,ciphers="AES256-SHA")

def checkidentity(a):
    c=a.getpeercert()
    print c
    c=dict([i[0] for i in c["subject"]])
    awaited={'commonName': u'note.crans.org',
             'countryName': u'FR',
             'emailAddress': u'legallic@crans.org',
             'localityName': u'Cachan',
             'organizationName': u'BDE ENS Cachan',
             'organizationalUnitName': u'Kfet',
             'stateOrProvinceName': u'\xc3\x8ele de France'}
    if all([c[cle]==awaited[cle] for cle in awaited.keys()]):
        return
    else:
        raise KeyboardInterrupt("Imposteur !")

def hello(socket,version):
    socket.send('["hello", "%s"]' % (version))
    return lit(a)

def login(socket,user,mdp="",typ="bdd"):
    if user in ["#1", "test"]:
        a.write('["login", ["#1","plop","bdd",[[],[],false]]]')
    elif user in ["vincent","moi"]:
        a.write('["login", ["vincent","plop","special",[]]]')
    elif user in ["toto"]:
        a.write('["login", ["toto","plop","bdd",[[],[],false]]]')
    else:
        a.write('["login", ["%s","%s","%s",[[],[],false]]]'%(user,mdp,typ))
    if mdp == "":
        import getpass
        mdp = getpass.getpass()
    return lit(a)
    
def search(socket,term):
    a.write('["search", %s]' % (term))
    return lit(a)

def lit(socket):
    try:
        obj=full_read(socket)
        if obj["retcode"]==0:
          return obj['msg']
        else:
          print obj["errmsg"]
          return obj["msg"]
    except ssl.SSLError:
        print "Rien à lire"

def do(stuff):
    """Dirty, 'cause I'm lazy."""
    global a
    a.write(json.dumps(stuff))


# Shortcuts
def _toggle_transactions(l, action="valider"):
    """(Dé)valide plein de transactions si on lui donne la liste d'ids."""
    global a
    for i in l:
        assert isinstance(i, int)
        print i,
        do(["%s_transaction" % (action,), i])
        out = lit(a)
        if out:
            print out

def cancel_transactions(l):
    """Annule plein de transactions. Mange une liste d'ids de transactions."""
    _toggle_transactions(l, action="devalider")

def validate_transactions(l):
    """Valide plein de transactions. Mange une liste d'ids de transactions."""
    _toggle_transactions(l, action="valider")

if __name__=="__main__":
    where=raw_input("quel serveur ?")
    #port=int(raw_input("port ? "))
    a=socket.socket()
    a=connect(a,where)
    a.settimeout(2)
    #checkidentity(a)
    print hello(a,"Python Client alpha")
    try:
        import secrets
        user = secrets.user
        password = secrets.password
    except ImportError:
        print "Vous pouvez enregistrer votre mot de passe dans la variable password dans secrets.py !"
        user = raw_input("username:")
        import getpass
        password = getpass.getpass("password:")
    print login(a, user, password)
    print "Socket créée dans la variable \"a\""
